With Ada.Text_IO; Use Ada.Text_IO;
With CondMax;
Procedure CondTest is 
   Package IntIO is new Integer_IO(Integer); Use IntIO;
   
   Function Even(I: Integer) return Boolean is
   Begin 
      Return (I mod 2) = 0;
   End Even;

   Type IntVector is array(Natural range <>) of Integer;

   Procedure MaxEven is new CondMax(Integer, Natural, IntVector, Even);

   Procedure Test(V: IntVector) is
   F: Boolean;
   I: Integer;
   Begin
      Put("Test: (");
      For J in V'Range loop
         Put(V(J));
         If J/=V'Last then 
            Put(", ");
         End if;
      End loop;
      New_line;
      MaxEven(V,F,I);
      If F then
         Put("Found. Max: V("); Put(I); Put(")="); Put(V(I));
      Else
         Put("Not found.");
      End if;
      New_line;
   End Test;

Begin
   Test((1,2,3,4,5,6,7,8));
   Test((1,3,5,7,9,11));
   Test((1,42,2,5,28,99));
End CondTest;